'*******************************************************************
'Aufgabe             : RC5-Empfnger
'Compiler            : BASCOM-AVR
'Hardware            : LCD an PortD
'                      TSOP1736 an PB.0
'                       ------
'                      |      |
'                      |______|
'                       | |  |
'                     GND VC Out
'Chip typ            : AT90S2313
'Wichtig !!! Pin PB.0 darf nicht weiter belastet werden (LED etc.)
'*******************************************************************

$regfile = "2313def.dat"                      'AT90S2313
$crystal = 3579545                            'Quarz 3.579 MHz
$lib "mcsbyte.lbx"                            'ergibt kleineren Code beim Compilieren

Config Rc5 = Pinb.0                           'TSOP an PB.0
Enable Interrupts                             'Interrupts erlauben

Config Pinb.4 = Output                        'Pinb.4 = Ausgang (evtl. Relais)

Dim Address As Byte                           'Variablenname und Typ festlegen
Dim Command As Byte                           

Lcd "Warte auf RC5..."                        'Ausgabe des Textes auf LCD
Do
 Getrc5(address , Command)                    'lese Adresse und Kommando von TSOP
 '255 = keine Taste gedrckt
 If Address < 255 Then                        'Taste an IR-FB gedrckt ?
                                              '  255 = keine Taste gedrckt
    Command = Command And &B10111111          'lsche Toggle-Bit
    Locate 2 , 5                              'LCD-Cursor auf Zeile2, Spalte5
    Lcd Address                               'gebe Adresse auf LCD aus
    Locate 2 , 14                             'LCD-Cursor auf Zeile2, Spalte14
    Lcd Command                               'gebe Kommando auf LCD aus
    If Address = 1 Then                       'TV-Fernbedienung
      If Command = 12 Then                    'wurde Power-Taste an IR-FB gedrckt ?
         Toggle Portb.4                       'schalte Relais um (an oder aus)
      End If
    End if
    Waitms 350                                'warte 350 Millisekunden
 Else                                         'keine Taste an IR-FB gedrckt ?
    Locate 2 , 1                              'LCD-Cursor auf Zeile2, Spalte1
    Lcd "Adr:     Cmd:    "                   'Lsche letzte Adresse und Kommando
 End If

Loop
End